/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.carlos.math.functions;

import com.numerico.algebralineal.Matrix;

public class InflectedPoint 
{
	public static final int TYPE_MAXIM = 1;
	public static final int TYPE_MINIM = -1;
	public static final int TYPE_INFLECTED = 0;
	
	private boolean isAborderPoint;
	private int dimension;
	private double[] coordinates;
	private VariabledFunction function;
	private boolean isInflectedPoint;
	public InflectedPoint(double[] coordinates, VariabledFunction f) 
	{
		super();
		this.isInflectedPoint = false;
		this.coordinates = coordinates;
		isAborderPoint = false;
		this.function = f;
		this.dimension = coordinates.length;
	}
	
	public int getType() throws Exception
	{
		Matrix hessian;
		try 
		{
			hessian = new Matrix(function.hessian(coordinates));
		} 
		catch (Exception e) 
		{
			throw e;
		}
		if(hessian.isDefinitePositive())
		{
			return TYPE_MINIM;
		}
		if(hessian.isDefiniteNegative())
		{
			return TYPE_MINIM;
		}
		return TYPE_INFLECTED;
	}
	
	public double[] getValue()
	{
		try {
			
			return function.f(coordinates);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			try {
				throw e;
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				return new double[1];
			}
		}
	}


	public void setBorderPoint(boolean isAborderPoint) {
		this.isAborderPoint = isAborderPoint;
	}

	public boolean isABorderPoint()
	{
		return isAborderPoint;
	}
	
	public int getDimension() {
		return dimension;
	}

	public void setDimension(int dimension) {
		this.dimension = dimension;
	}

	public double[] getCoordinates() {
		return coordinates;
	}

	public void setCoordinates(double[] coordinates) {
		this.coordinates = coordinates;
	}

	public VariabledFunction getFunction() {
		return function;
	}

	public void setFunction(VariabledFunction function) {
		this.function = function;
	}

	public boolean isInflectedPoint() {
		return isInflectedPoint;
	}

	public void setInflectedPoint(boolean isInflectedPoint) {
		this.isInflectedPoint = isInflectedPoint;
	}
	
	
}