/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.carlos.math.numerico.util;

import de.jtem.mathExpr.ExpressionConfiguration;
import de.jtem.mathExpr.evaluator.realEvaluator.Real;
import de.jtem.mathExpr.evaluator.realEvaluator.RealType;



public class FunctionParser 
{

	public static final String space = "{space}";
	
	public static final String parentesis = "\\(.+\\)";
	public static final char  replaceCorch1 = '[';
	public static final char  replaceCorch2 = '}';
	public static final char  replaceLlav1 = '{';
	public static final char  replaceLlav2 = '}';
	
	
	public static final char parentesis1 = '(';
	public static final char parentesis2 = ')';
	
	int k= 0;
	public static void main(String args[])
	{
		/*
		Divide d = new Divide();
		System.out.println(d.evaluate(1,2));
		FunctionParser f = new FunctionParser();
		String function = "sin(3x+1*(x+2))/(x+4)";
		f.parse(function);
		*/
		ExpressionConfiguration config=new ExpressionConfiguration(RealType.TYPE);
/*
		config.defineFunction("f", new String[] {"x"}, "sin(x)");
		config.defineFunction("g", new String[] {"x"}, "cos(x)");
		config.defineFunction("tan", new String[] {"x"}, "(f(x))/(g(x))");
		config.defineFunction("cotan", new String[] {"x"}, "(g(x))/(f(x))");
		config.defineFunction("cosec", new String[] {"x"}, "(1)/(f(x))");
		config.defineFunction("sec", new String[] {"x"}, "(1)/(g(x))");
		
		config.defineFunction("cosh", new String[] {"x"}, "(exp(x) - exp(-x))/(2)");
		config.defineFunction("sinh", new String[] {"x"}, "(exp(x) + exp(-x))/(2)");
		config.defineFunction("tanh", new String[] {"x"}, "(sinh(x))/(cosh(x))");
		config.defineFunction("cotanh", new String[] {"x"}, "(cosh(x))/(sinh(x))");
		*/
		config.defineFunction("abs", new String[] {"x"}, "x*x");
		

		Real a = new Real();
		config.defineVariable("x", a, RealType.TYPE);
		config.setExpression("abs(x)");

		Real[] result=new Real[10];
		  for(int i=0; i<result.length; i++)
		  {
		    a.assign(i);
		    result[i]=new Real((Real)config.evaluateExpression());
		      //it's very important to create a new Real object for every
		      //result, because each evaluation returns the same result object
		      //(there is none instantiation during an evaluation)
		    System.out.println(i + " " + result[i]);
		  }
		
		}
	
	
}






abstract class genericFunciton
{
	abstract double evaluate(double... a);
}

 class Sin extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.sin(a[0]);
	}
}

 class Cos extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.cos(a[0]);
	}
}

 class Tan extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.tan(a[0]);
	}
}

 class ArcoSin extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.asin(a[0]);
	}
}

 class ArcoCos extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.acos(a[0]);
	}
}
 class ArcoTan extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.atan(a[0]);
	}
}

 class Sec extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return 1.0/Math.cos(a[0]);
	}
}

 class CoSec extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return 1.0/Math.sin(a[0]);
	}
}

 class Exp extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.exp(a[0]);
	}
}

 class Log extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.log(a[0]);
	}
}

 class Log10 extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.log10(a[0]);
	}
}

 class Cosh extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.cosh(a[0]);
	}
}

 class Sinsh extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		return Math.sinh(a[0]);
	}
}


 class Suma extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		double result = 0;
		for(double b: a)
		{
			result += b;
		}
		return result;
	}
}

 class Resta extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		double result = 0;
		for(double b: a)
		{
			result -= b;
		}
		return result;
	}
}

 class Multiplica extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		double result = 1;
		for(double b: a)
		{
			result *= b;
		}
		return result;
	}
}

 class Divide extends genericFunciton
{
	@Override
	double evaluate(double... a) {
		
		return a.length> 1 ? a[0] / a[1] : a[0];
	}
	
}
 
 class Pow extends genericFunciton
 {
 	@Override
 	double evaluate(double... a) {
 		
 		return Math.pow(a[0], a[1]);
 	}
 }
 
 class SQRT extends genericFunciton
 {
 	@Override
 	double evaluate(double... a) {
 		
 		return Math.sqrt(a[0]);
 	}
 }
 
 class Identity extends genericFunciton
 {
 	@Override
 	double evaluate(double... a) {
 		
 		return a[0];
 	}
 	
 }